Rem
Rem BackUpSource
Rem ------------
Rem Jesper Wachs, version 1, January 2020.
Rem
Rem Global variables.
Option Explicit
Dim f, fso, arg, library, user, pwd, ibmi, fileName, fileType, dataType, oneLine
Rem
Rem GetDataFile
Rem -----------
Rem Gets a data file and store it as a CSV file.
Rem
Rem Be aware that if your datafiles have more than one member, this method
Rem must be changed to get all the members. This code below will only read
Rem the first member.
Rem
Rem Also, check files transferred to the PC. If Alphanumeric fields contains
Rem binary data, you will need another method to retrieve the data, as this
Rem method will translate data to ASCII and bonary data will get corrupted.
Rem
Sub GetDataFile(user, pwd, host, lib, file)
   Dim outFile, objFile, objShell
   outFile = ".\" + lib + "\" + file + ".script"
   WScript.Echo "Getting data file ..: " + lib + "/" + file

   Set objFile = fso.CreateTextFile(outFile, True)

   objFile.WriteLine "open " + host
   objFile.WriteLine user
   objFile.WriteLine pwd
   objFile.WriteLine "quote rcmd cpytoimpf " + lib + "/" + file + " TOSTMF('/home/tempfile.pf') rcddlm(*CRLF)"
   objFile.WriteLine "ascii"
   objFile.WriteLine "get /home/tempfile.pf .\" + lib + "\" + file + ".PF"
   objFile.WriteLine "del /home/tempfile.pf"
   objFile.WriteLine "quit"

   objFile.Close
    
   Set objShell = WScript.CreateObject ("WScript.shell")
   objShell.run "cmd /c ftp -s:" + outFile + " >> BackUpSrcDta-3.log 2>&1", , True
   objShell.run "cmd /c del " + outFile, , True
   Set objShell = Nothing
End Sub
Rem
Rem GetSourceFile
Rem -------------
Rem Gets a source file.
Rem
Sub GetSourceFile(user, pwd, host, lib, file)
   Dim outFile, objFile, objShell
   outFile = ".\" + lib + "\" + file + ".script"
   WScript.Echo "Getting source file : " + lib + "/" + file

   Set objFile = fso.CreateTextFile(outFile, True)

   objFile.WriteLine "open " + host
   objFile.WriteLine user
   objFile.WriteLine pwd
   objFile.WriteLine "quote rcmd dspfd " + lib + "/" + file + " TYPE(*MBRLIST) OUTPUT(*OUTFILE) OUTFILE(QTEMP/DSPFDMBR)"
   objFile.WriteLine "ascii"
   objFile.WriteLine "get /qsys.lib/qtemp.lib/dspfdmbr.file .\" + lib + "\" + file + ".MBRLIST"
   objFile.WriteLine "quote rcmd dltf qtemp/dspfdmbr"
   objFile.WriteLine "quit"

   objFile.Close
    
   Set objShell = WScript.CreateObject ("WScript.shell")
   objShell.run "cmd /c ftp -s:" + outFile + " >> BackUpSrcDta-4.log 2>&1", , True
   objShell.run "cmd /c del " + outFile, , True
   Set objShell = Nothing
   
   GetSourceMembers user, pwd, host, lib, file, ".\" + lib + "\" + file + ".MBRLIST"
   
End Sub
Rem
Rem GetSourceMembers
Rem ----------------
Rem Gets source members and store them as a folder with text files, one of each member
Rem
Sub GetSourceMembers(user, pwd, host, lib, srcfile, file)
   Dim f, oneLine, filename, library, member, mbrtype, objFile, outFile, objShell

   Set objShell = WScript.CreateObject ("WScript.shell")
   
   objShell.run "cmd /c md .\" + lib + "\" + srcfile, , True

   outFile = ".\" + lib + "\" + srcfile + ".script"   
   Set objFile = fso.CreateTextFile(outFile, True)
   objFile.WriteLine "open " + host
   objFile.WriteLine user
   objFile.WriteLine pwd
   objFile.WriteLine "ascii"

   Set f = fso.OpenTextFile(file)
   
   Do Until f.AtEndOfStream
      oneLine = f.ReadLine
      
      filename = trim(Mid(oneLine, 14, 10))
      library = trim(Mid(oneLine, 24, 10))
      member = trim(Mid(oneLine, 65, 10))
      mbrtype = trim(Mid(oneLine, 167, 10))
      
      If member > "" Then
         objFile.WriteLine "get /qsys.lib/" + library + ".lib/" + filename + ".file/" + member + ".mbr .\" + lib + "\" + srcfile + "\" + member + "." + mbrtype
      End If
   Loop
   objFile.WriteLine "quit"
   objFile.Close

   objShell.run "cmd /c ftp -s:" + outFile + " >> BackUpSrcDta-5.log 2>&1", , True
   objShell.run "cmd /c del " + outFile, , True
   Set objShell = Nothing

   f.Close

End Sub
Rem
Rem Main line
Rem ---------
Rem
Set arg = WScript.Arguments

user = arg(0)
pwd = arg(1)
ibmi = arg(2)
library = arg(3)
filename = arg(4)

Set fso = CreateObject("Scripting.FileSystemObject")
Set f = fso.OpenTextFile(filename)

Do Until f.AtEndOfStream
   oneLine = f.ReadLine

   fileName = Trim(Mid(oneLine, 14, 10))
   fileType = Mid(oneLine, 34, 1)
   dataType = Mid(oneLine, 62, 1)
   Rem
   Rem We want to read file that are Physical Data and Source files
   Rem
   If fileType = "P" Then
      If dataType = "D" Then
         GetDataFile user, pwd, ibmi, library, fileName
      ElseIf dataType = "S" Then
         GetSourceFile user, pwd, ibmi, library, fileName
      End If
   End If   
Loop

f.Close
